#version 330 core

in vec3 WorldPosition;
in vec2 Texcoords;
in vec3 WorldNormal;

uniform sampler2D color_texture;
uniform vec4 color;

uniform mat3 normalMatrix;
uniform mat4 viewMatrix;

uniform bool hasColorTexture = true;

layout (location = 0) out vec4 gWorldPosition;
layout (location = 1) out vec4 gWorldNormal;
layout (location = 2) out vec4 gDiffuse;


void main()
{
    gWorldPosition.xyz = WorldPosition;
	gWorldNormal.xyz = normalize(WorldNormal);
	gDiffuse = (hasColorTexture) ? texture(color_texture, Texcoords) : color;
	  
		
	gWorldPosition.a = 1;
	gWorldNormal.a = 1;

}