#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoord;


uniform mat4 modelMatrix;
uniform mat4 viewMatrix;

uniform mat3 normalMatrix;
uniform mat4 modelViewProjectionMatrix;


out vec3 WorldPosition;
out vec3 WorldNormal;
out vec2 Texcoords;



void main() 
{
	gl_Position = modelViewProjectionMatrix * vec4(position, 1.0f);
	
	// Position in World Space
	WorldPosition = (modelMatrix * vec4(position, 1.0f)).xyz;
	// Normal in World Space
    WorldNormal =  normalMatrix * normal;
	// Texcoords in UV Space
	Texcoords = texCoord; 
  
}
